<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';
import VideoCarouselCard from './video-carousel-card.vue';
import { CtfButton, CtfCardGroup } from '~/models';
export default Vue.extend({
  name: 'VideoCarousel',
  components: { VideoCarouselCard },
  props: {
    controls: {
      type: Object,
      required: false,
      default: () => ({ prev: 'previous slide', next: 'next slide' }),
    },
    slides: {
      type: Array,
      required: false,
      default: () => [],
    },
    header: {
      type: String,
      default: null,
    },
    subheader: {
      type: String,
      default: null,
    },
    card: {
      type: Object as PropType<CtfCardGroup>,
      required: false,
      default: () => {},
    },
    cta: {
      type: Object as PropType<CtfButton>,
      required: false,
      default: () => {},
    },
    isHero: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  data() {
    return {
      pressed: false,
      pos: {},
      scrollPosition: 0,
      scrollPercentage: 0,
      test: 0,
      currentStep: 0,
      totalItems: [],
      isUsingButtons: false,
      scrollDistance: 0,
      animateHero: false,
      animationTimeout: null,
      inactiveArrow: true,
      hasScroll: true,
      totalSteps: 0,
      itemDistances: [],
    };
  },
  mounted() {
    this.checkHasScroll();
    window.addEventListener('resize', this.checkHasScroll);
  },
  destroyed() {
    window.removeEventListener('resize', this.checkHasScroll);
  },
  methods: {
    checkHasScroll() {
      this.totalSteps = this.$refs.items.length;
      this.hasScroll =
        this.$refs.wrapper.scrollWidth > this.$refs.wrapper.offsetWidth;
    },
    scrollOnButtonPrev() {
      if (this.currentStep > 0) {
        this.currentStep = this.currentStep - 1;
      } else {
        this.currentStep = this.totalSteps - 1;
      }
      this.$refs.items[this.currentStep].scrollIntoView({
        behavior: 'smooth',
        block: 'nearest',
        inline: 'center',
      });
    },
    scrollOnButtonNext() {
      if (this.currentStep < this.totalSteps - 1) {
        this.currentStep = this.currentStep + 1;
      } else {
        this.currentStep = 0;
      }
      this.$refs.items[this.currentStep].scrollIntoView({
        behavior: 'smooth',
        block: 'nearest',
        inline: 'center',
      });
    },
  },
});
</script>

<template>
  <section class="video-carousel">
    <SlpContainer>
      <SlpRow>
        <SlpColumn :cols="6">
          <SlpColumn :cols="11">
            <SlpTypography variant="body1-bold" tag="div" class="">
              {{ subheader }}
            </SlpTypography>
            <SlpTypography variant="heading1-bold" tag="h1" class="slp-my-16">
              {{ header }}
            </SlpTypography>
            <SlpButton
              v-if="cta"
              :href="cta.fields.externalUrl"
              class="button"
              variant="tertiary"
              :data-ga-name="cta.fields.dataGaName"
              :data-ga-location="cta.fields.dataGaLocation"
            >
              {{ cta.fields.text }}
              <SlpIcon
                variant="product"
                name="chevron-lg-right"
                class="slp-ml-8"
              />
            </SlpButton>
          </SlpColumn>
        </SlpColumn>
        <SlpColumn :cols="6">
          <div class="video-carousel__wrapper">
            <div ref="wrapper" class="video-carousel__track" @scroll="onScroll">
              <div
                v-for="item in card"
                ref="items"
                :key="item?.fields?.title"
                class="video-carousel__card"
              >
                <VideoCarouselCard
                  :card="item"
                  :preload-images="isHero ? true : false"
                />
              </div>
            </div>
            <div v-if="hasScroll" class="arrow-btns video-carousel__controls">
              <SlpButton
                class="arrow-btns__btn"
                variant="icon"
                aria-label="Previous case study"
                @click.native="scrollOnButtonPrev"
                ><SlpIcon
                  variant="product"
                  name="chevron-lg-left"
                  slp-color="color-surface-500"
                />{{ controls.prev }}
              </SlpButton>
              <SlpButton
                class="arrow-btns__btn"
                variant="icon"
                aria-label="Next case study"
                @click.native="scrollOnButtonNext"
                ><SlpIcon
                  variant="product"
                  name="chevron-lg-right"
                  slp-color="color-surface-500"
                />
                {{ controls.next }}</SlpButton
              >
            </div>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.video-carousel {
  overflow: hidden;
  position: relative;
  padding: 64px 0px;
  @media (min-width: $breakpoint-md) {
    padding: 120px 0px;
  }
  &:after {
    content: '';
    position: absolute;
    left: 0;
    bottom: 0;
    width: 100%;
    height: 50%;
    background: linear-gradient(
      0deg,
      #ffffff 0%,
      #ffffff 23.86%,
      rgba(255, 255, 255, 0) 97.02%
    );
  }
  &:before {
    content: '';
    position: absolute;
    left: 0;
    top: 0;
    width: 101%;
    height: 200%;
    transform: scaleY(-1);
    background: radial-gradient(
        50.08% 44.51% at 100% 100%,
        rgba(169, 137, 245, 0.2) 0,
        rgba(119, 89, 194, 0) 100%
      ),
      radial-gradient(
        60.76% 48.01% at 0 100%,
        rgba(226, 67, 41, 0.2) 0,
        rgba(226, 67, 41, 0) 100%
      ),
      #fff;
  }
  &__wrapper {
    overflow: visible;
    width: 100%;
    margin-top: 32px;
    @media (min-width: $breakpoint-md) {
      width: 50vw;
      margin-top: 0;
    }
  }
  &__track {
    overflow: scroll;
    display: flex;
    scrollbar-width: none;
    scroll-behavior: smooth;
    scroll-snap-type: x mandatory;
    pointer-events: none;
    &::-webkit-scrollbar {
      display: none;
      scrollbar-width: none;
    }
  }
  &__card {
    border: 1px solid $color-primary-100;
    border-radius: 8px;
    width: 100%;
    flex: 1 0 100%;

    scroll-snap-align: start;
    overflow: hidden;
    img {
      width: 100%;
    }
    &:last-of-type {
      margin-right: 1px;
    }
    @media (min-width: $breakpoint-sm) {
      flex: 1 0 70%;
      max-width: 585px;
      margin: 0 20px 0 0;
    }
  }
  &__card__description {
    padding: 32px;
  }
  &__controls {
    display: flex;
    align-items: center;
    justify-content: right;
    margin-top: 32px;
  }
  .arrow-btns {
    display: flex;
    gap: 16px;
    align-items: flex-end;
    padding-bottom: 24px;
    justify-content: center;
    @media (min-width: $breakpoint-md) {
      justify-content: right;
      width: 70%;
    }
    &__btn {
      justify-content: center;
      border-radius: 120px;
      border: 1px solid $color-surface-900;
      padding: 8px;
      height: 40px;
      width: 40px;

      :deep(.slp-icon) {
        transform: none !important;
      }
      background: white;

      &:hover {
        background-color: $color-surface-800;
      }
    }
  }
  &__button {
    padding: 0;
    :deep {
      .slp-icon {
        line-height: 1;
      }
    }
  }
  :deep {
    .slp-container {
      position: relative;
      z-index: 1;
    }
  }
}
</style>
